diff --git a/modules/codec/avcodec/encoder.c b/modules/codec/avcodec/encoder.c
index 95eef57..eadaeab 100644
--- a/modules/codec/avcodec/encoder.c
+++ b/modules/codec/avcodec/encoder.c
@@ -566,7 +566,14 @@ int OpenEncoder( vlc_object_t *p_this )
             p_enc->fmt_in.audio.i_channels = 2;
 
         p_enc->fmt_in.i_codec  = AOUT_FMT_S16_NE;
-        p_context->sample_rate = p_enc->fmt_out.audio.i_rate;
+        if( p_enc->fmt_out.i_codec == VLC_FOURCC('m','p','g','a') || p_enc->fmt_out.i_codec == VLC_FOURCC('m','p','3',' ') )
+        {
+            p_context->sample_rate = p_enc->fmt_in.audio.i_rate;
+        }
+        else
+        {
+            p_context->sample_rate = p_enc->fmt_out.audio.i_rate;
+        }
         p_context->channels    = p_enc->fmt_out.audio.i_channels;
 
         if ( p_enc->fmt_out.i_codec == VLC_FOURCC('m','p','4','a') )
